/* drawer -- class that draws rectangles representing files 
   Copyright (C) 2002 Aaron Bentley

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */


class Drawer
{
protected:
   Gdk_GC context;
   Gdk_Color curcolor;
   Gdk_Colormap colormap;
   Gdk_Window window;

public:
   Drawer(Gdk_Window const awindow);
   virtual ~Drawer()
   {}

   virtual void operator()(EntryRect const &cur, Gdk_Color rcolor);
};

class PrettyDrawer: public Drawer
{
public:
   PrettyDrawer(Gdk_Window const awindow);
   void operator()(EntryRect const &cur, Gdk_Color rcolor);
   void brightness(Gdk_Color &curcolor, float amount) const;
   void fg_brightness(Gdk_Color curcolor, float amount);
};
class DarkFirst: public PrettyDrawer
{
   public:
   DarkFirst(Gdk_Window const awindow);
   void operator()(EntryRect const &cur, Gdk_Color rcolor);
};


