//#include "xml.h"
#include "editvar.h"
#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdlib>

void EditVar::htmlTable(string &html) const
{
   html+="<tr>\n\t<td align=\"right\">";
   html+=getdisplay();
   html+="</td>\n\t<td>";
   formEl(html);
   html+="</td>\n</tr>\n";
}

void EditVarList::operator=(std::map<string, string> &input)
{
   iterator cur, stop;
   stop=end();
   for (cur=begin(); cur!=stop; cur++)
   {
      (**cur)=input;
   }
}

/*void EditVarList::operator=(xml::Xtree const &parent)
{
   iterator cur, stop;
   stop=end();
   for (cur=begin(); cur!=stop; cur++)
   {
      (**cur)=parent;
   }
}*/

void EditVarList::htmlTable(string &html)
{
   iterator cur, stop;
   stop=end();
   for (cur=begin(); cur!=stop; cur++)
   {
      (**cur).htmlTable(html);
   }
}

/*void EditVarList::addXml(xml::Xtree &xml)
{
   iterator cur, stop;
   stop=end();
   for (cur=begin(); cur!=stop; cur++)
   {
      (**cur).addXml(xml);
   }
}*/

Editable &Editable::operator=(std::map<string, string> &input)
{
   EditVarList ev;
   getEditVars(ev);
   ev=input;
   return *this;
}

void Editable::htmlTable(string &html) const
{
   EditVarList ev;
   const_cast<Editable *>(this)->getEditVars(ev);
   ev.htmlTable(html);
}

/*void Editable::addXml(xml::Xtree &xml) const
{
   EditVarList ev;
   const_cast<Editable *>(this)->getEditVars(ev);
   ev->addXml(xml);
}*/

/*Editable &Editable::operator=(xml::Xtree const &xml)
{
   EditVarList ev;
   const_cast<Editable *>(this)->getEditVars(ev);
   ev=xml;
   return *this;
}*/
EditVar &EditBool::operator=(string const &input)
{
   mybool = (input=="y" || input=="yes" || input=="true");
   return *this;
}

EditVar &EditBool::operator=(char const input[])
{
   if (input==NULL) 
   {
      mybool=false;
      return *this;
   }
   else 
   {
      string tmp=input;
      return operator=(tmp);
   }
}

void EditBool::formEl(string &html) const
{
   html+="<input type=\"checkbox\"";
   //html+=" name=\""+xml::encode(varname)+"\"";
   html+=" value=\"true\"";
   if (mybool)
      html+=" checked";
   html+=" />";
}

EditVar &EditFieldString::operator=(string const &input)
{
   mystring=input;
   return *this;
}

void EditFieldString::formEl(string &html) const
{
   html+="<input type=\"text\"";
   //html+=" name=\""+xml::encode(varname)+"\"";
   //html+=" value=\""+xml::encode(mystring)+"\"";
   html+=" />";
}

EditVar &EditBoxString::operator=(string const &input)
{
   mystring=input;
   return *this;
}
void EditBoxString::htmlTable(string &html) const
{
   html+="<tr>\n\t<td colspan=2>";
   html+=getdisplay();
   html+="<br />\n";
   formEl(html);
   html+="</td></tr>";
}
void EditBoxString::formEl(string &html) const
{
   html+="<textarea wrap=\"soft\" rows=\"10\" cols=\"30\"";
   //html+=" name=\""+xml::encode(varname)+"\">";
   //html+=xml::encode(mystring);
   html+="</textarea>";
}

EditVar &EditInt::operator=(string const &input)
{
   myint=std::strtol(input.c_str(), NULL, 10);
   return *this;
}

void EditInt::formEl(string &html) const
{
   std::ostringstream intstring;
   intstring << myint;
   html+="<input type=\"text\"";
   //html+=" name=\""+xml::encode(varname)+"\"";
   html+=" value=\""+intstring.str()+"\"";
   html+=" />";
}
/**
 * \brief Appends the EditVar to the string as an HTML table
 */
string &operator+=(string &html, const EditVar &var)
{
   var.htmlTable(html);
   return html;
}

/**
 * \brief Appends all the variables in the EditVarList to the string as an HTML
 * table 
 */
string &operator+=(string &html, EditVarList &vars)
{
   vars.htmlTable(html);
   return html;
}

/**
 * \brief Appends all the variables in the Editable to the string as an HTML
 * table
 * \param html The string to add variables to
 * \param obj The Editable to output as HTML
 */
string &operator+=(string &html, Editable &obj)
{
   obj.htmlTable(html);
   return html;
}



/*EditVarList *Gig::getEditVars()
{
   EditVarList *ev=new EditVarList();
   ev->push_back(new EditFieldString(venueID, "venueid", "Venue"));
   ev->push_back(new EditFieldString(time, "time", "Time"));
   ev->push_back(new EditBoxString(description, "description", "Description"));
   return ev;
}*/
/*
#include "exlib.h"
#include "error.h"
#include "cgi.h"
int main(void)
{
   string output;
   EditVarList list;
   CgiOut webout;
   CgiIn webin;

   try
   {
      webin.activate();
      list=webin;
      Gig mygig;
      
      xml::Xtree *lala=xml::newTag("xml");
      xml::Parser parser;
      parser.doFile(*lala, "gig.xml");
      mygig=*lala->getConstEl("gig");
      mygig=webin;
      output+="<form action=editvar.cgi method=get><table border=1>\n";
      output+=mygig;
      output+="<tr><td colspan=\"2\"><input type=\"submit\"></td></tr>";
      output+="</table></form>\n";
      
      xml::Xtree *root=xml::newTag("gig");
      (*root)+=mygig;
      string parsedata;
      xml::GetText outtext(parsedata);
      output+="<!--";
      root->forEach(outtext, true);
      output+="-->";

      std::ofstream meal("gig.xml");
      meal << parsedata;
      
      xml::GetText nextstage(output);
      lala->forEach(nextstage, true);
      webout.write(output);
   }
   catch(err::Error *err)
   {
      webout.write(err->getPlainText());
      delete err;
   }
   return 0;
}*/
