/* Watcher -- Base class for classes that react when an object is changed
   Copyright (C) 2002 Aaron Bentley

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
#ifndef _WATCHER_H_
#define _WATCHER_H_ //make idempotent
/**
 * \brief The Watcher interface is for classes that watch other classes.
 * \param T The type of class to watch
 */
template<typename T>
class Watcher
{
public:
   /** Called when the watched object is modified.
    * \param modobj The modified object
    */
   virtual void modified(T const &modobj)=0;
};

#endif //_WATCHER_H_
